#include "LibSip_Interface.hh"
#include "LibSip_SIPTypesAndValues.hh"

#include "sip_layer_factory.hh"

#include "loggers.hh"

#include "converter.hh"

sip_layer::sip_layer(const std::string & p_type, const std::string & p_param) : t_layer<LibSip__Interface::SipPort>(p_type), _params() {
  loggers::get_instance().log(">>> sip_layer::sip_layer: %s, %s", to_string().c_str(), p_param.c_str());
  // Setup parameters
  params::convert(_params, p_param);
}

void sip_layer::send_data(OCTETSTRING& data, params& p_params) {
  loggers::get_instance().log_msg(">>> sip_layer::send_data: ", data);

  OCTETSTRING os;
  // Encode SIP message
//  _codec.encode(msg, os);
  send_to_all_layers(os, p_params);
}

void sip_layer::receive_data(OCTETSTRING& data, params& p_params)
{
  loggers::get_instance().log_msg(">>> sip_layer::receive_data: ", data);

  // Decode SIP message
  OCTETSTRING payload;
  receive_to_all_layers(payload, p_params);
}

sip_layer_factory sip_layer_factory::_f;

